"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _UserStatus:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _UserStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_UserStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    USER_STATUS_UNKNOWN: _UserStatus.ValueType  # 0
    """User status undefined"""
    USER_STATUS_STAGED: _UserStatus.ValueType  # 1
    """Staged status, is when the user object is first created, before the activation flow is initiated, or if there is a pending admin action."""
    USER_STATUS_PROVISIONED: _UserStatus.ValueType  # 2
    """Provisioned status, is when the user object is provisioned, but the user has not provided verification by clicking through the activation email or provided a password."""
    USER_STATUS_ACTIVE: _UserStatus.ValueType  # 3
    """Active status, is when:"""
    USER_STATUS_RECOVERY: _UserStatus.ValueType  # 4
    """ * An admin adds a user and sets the user password without requiring email verification.
     * An admin adds a user, sets the user password, and requires the user to set their password when they first sign-in.
     * A user self-registers into a custom app or IDP and email verification is not required.
     * An admin explicitly activates the user.
    Recovery status, when the user requests a password reset or an admin initiates one on their behalf.
    """
    USER_STATUS_PASSWORD_EXPIRED: _UserStatus.ValueType  # 5
    """Password expired, status when the users' password has expired and the account requires an update to the password before a user is granted access."""
    USER_STATUS_LOCKED_OUT: _UserStatus.ValueType  # 6
    """Locked out status, is when the user exceeds the number of login attempts defined in the login policy."""
    USER_STATUS_SUSPENDED: _UserStatus.ValueType  # 7
    """Suspended status, when an admin explicitly suspends the user account."""
    USER_STATUS_DEPROVISIONED: _UserStatus.ValueType  # 8
    """Deprovisioned status, is when an administrator explicitly deactivates or deprovisions/deletes the account."""

class UserStatus(_UserStatus, metaclass=_UserStatusEnumTypeWrapper): ...

USER_STATUS_UNKNOWN: UserStatus.ValueType  # 0
"""User status undefined"""
USER_STATUS_STAGED: UserStatus.ValueType  # 1
"""Staged status, is when the user object is first created, before the activation flow is initiated, or if there is a pending admin action."""
USER_STATUS_PROVISIONED: UserStatus.ValueType  # 2
"""Provisioned status, is when the user object is provisioned, but the user has not provided verification by clicking through the activation email or provided a password."""
USER_STATUS_ACTIVE: UserStatus.ValueType  # 3
"""Active status, is when:"""
USER_STATUS_RECOVERY: UserStatus.ValueType  # 4
""" * An admin adds a user and sets the user password without requiring email verification.
 * An admin adds a user, sets the user password, and requires the user to set their password when they first sign-in.
 * A user self-registers into a custom app or IDP and email verification is not required.
 * An admin explicitly activates the user.
Recovery status, when the user requests a password reset or an admin initiates one on their behalf.
"""
USER_STATUS_PASSWORD_EXPIRED: UserStatus.ValueType  # 5
"""Password expired, status when the users' password has expired and the account requires an update to the password before a user is granted access."""
USER_STATUS_LOCKED_OUT: UserStatus.ValueType  # 6
"""Locked out status, is when the user exceeds the number of login attempts defined in the login policy."""
USER_STATUS_SUSPENDED: UserStatus.ValueType  # 7
"""Suspended status, when an admin explicitly suspends the user account."""
USER_STATUS_DEPROVISIONED: UserStatus.ValueType  # 8
"""Deprovisioned status, is when an administrator explicitly deactivates or deprovisions/deletes the account."""
global___UserStatus = UserStatus

@typing_extensions.final
class UserProperties(google.protobuf.message.Message):
    """Properties of "user" objects."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EMAIL_FIELD_NUMBER: builtins.int
    PICTURE_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    ENABLED_FIELD_NUMBER: builtins.int
    CONNECTION_ID_FIELD_NUMBER: builtins.int
    email: builtins.str
    """main email address of user"""
    picture: builtins.str
    """URL to user's picture"""
    status: global___UserStatus.ValueType
    """user lifecycle status"""
    enabled: builtins.bool
    """enabled (false prevents the user from accessing anything)"""
    connection_id: builtins.str
    """ID of the IDP connection the user is associated with."""
    def __init__(
        self,
        *,
        email: builtins.str = ...,
        picture: builtins.str = ...,
        status: global___UserStatus.ValueType = ...,
        enabled: builtins.bool = ...,
        connection_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["connection_id", b"connection_id", "email", b"email", "enabled", b"enabled", "picture", b"picture", "status", b"status"]) -> None: ...

global___UserProperties = UserProperties
